//
//  UIView+Shake.m
//  WiggleEffectSimple
//
//  Created by harald bregu on 01/07/13.
//  Copyright (c) 2013 harald bregu. All rights reserved.
//

#import "UIView+Shake.h"


@implementation UIView (Shake) 

-(void)startAnimationWithShakeType:(ShakeType)shakeType{
    
    CGAffineTransform leftShake;
    CGAffineTransform rightShake;

    
    switch (shakeType) {
        case ShakeTypeNormal:
            leftShake = CGAffineTransformMakeTranslation(5, 0);
            rightShake = CGAffineTransformMakeTranslation(-5, 0);
            break;
        case ShakeTypeWiggle:
            leftShake = CGAffineTransformMakeRotation(69);
            rightShake = CGAffineTransformMakeRotation(-69);
            break;
        case ShakeTypeHeart:
            leftShake = CGAffineTransformMakeScale(1.1, 1.1);
            rightShake = CGAffineTransformMakeScale(0.9, 0.9);
            break;
        default:
            leftShake = CGAffineTransformMakeScale(1.1, 1.1);
            rightShake = CGAffineTransformMakeScale(0.9, 0.9);
            break;
    }
    
    self.transform = leftShake; // startingPoint
    
    [UIView beginAnimations:@"Shake" context:(__bridge void *)(self)];
    [UIView setAnimationRepeatAutoreverses:YES];
    [UIView setAnimationRepeatCount:ANIMATION_REPEATCOUNT];
    [UIView setAnimationDuration:ANIMATION_DURATION];
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(shakeEnded:finished:context:)];
    
    self.transform = rightShake;
    
    [UIView commitAnimations];
}

-(void)shakeEnded:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context {
    
    if ([finished boolValue]) {
        UIView * item = (__bridge UIView *)context;
        item.transform = CGAffineTransformIdentity;
        
    }
}


@end
